-- player/init.lua

dofile(minetest.get_modpath("player_api") .. "/api.lua")

-- Default player appearance
player_api.register_model("character.b3d", {
	animation_speed = 20,
	visual_size = {x=6, y=6},
	textures = {"character.png"},
	animations = {
		-- Standard animations.
		stand     = {x = 0,   y = 0},
		walk      = {x = 0, y = 40},
		mine      = {x = 0, y = 0},
		walk_mine = {x = 0, y = 40},
	},
	collisionbox = {-0.100, 0.100, -0.100, 0.100, 1.100, 0.100},
	stepheight = 0.4,
	eye_height = 1.55,
})

-- Update appearance when the player joins
minetest.register_on_joinplayer(function(player)
	player_api.player_attached[player:get_player_name()] = false
	player_api.set_model(player, "character.b3d")
	player:set_local_animation(
		{x = 0,   y = 0},
		{x = 0, y = 0},
		{x = 0, y = 0},
		{x = 0, y = 0},
		20
	)
end)


-- The hand
minetest.override_item("", {
	wield_image = "wieldhand.png",
	wield_scale = {x=1,y=1,z=2.5},
	range = 4,
	tool_capabilities = {
		full_punch_interval = 0.9,
		max_drop_level = 0,
		groupcaps = {
			crumbly = {times={[2]=3.00, [3]=0.70}, uses=0, maxlevel=1},
			snappy = {times={[3]=0.40}, uses=0, maxlevel=1},
			oddly_breakable_by_hand = {times={[1]=3.50,[2]=2.00,[3]=0.70}, uses=0}
		},
		damage_groups = {fleshy=0},
	}
})

